//
//  CoreDatabase.h
//
//  Created by Ingo Kasprzak on 03.08.11.
//  Copyright 2010 Silutions. All rights reserved.
//

#import <CoreData/CoreData.h>

#define SHAREDDATABASE_DEFAULT_DATABASENAME @"database"
#define SHAREDDATABASE_DEFAULT_DATAMODELNAME @"datamodel"

@interface CoreDatabase : NSObject {
@private
	NSManagedObjectModel *managedObjectModel;
	NSManagedObjectContext *managedObjectContext;
	NSPersistentStoreCoordinator *persistentStoreCoordinator;

	NSString* databaseName;
	NSString* datamodelName;
}
@property (strong, readonly) NSManagedObjectModel *managedObjectModel;
@property (strong, readonly) NSManagedObjectContext *managedObjectContext;


- (id)fetchObjectForEntityClass:(Class)entityClass
				  withPredicate:(id)stringOrPredicate, ...;

- (NSSet *)fetchObjectsForEntityClass:(Class)entityClass
						withPredicate:(id)stringOrPredicate, ...;

- (NSArray *)fetchObjectsForEntityClass:(Class)entityClass
						 sortDescriptor:(id)stringOrDescriptorOrArray
						  withPredicate:(id)stringOrPredicate, ...;

- (NSUInteger)countForEntityClass:(Class)entityClass
					withPredicate:(id)stringOrPredicate, ...;

- (NSFetchRequest *)fetchRequestTemplateForName:(NSString *)name;

- (void)releaseDatabase;

- (id)init;
- (id)initWithDatabaseName:(NSString*)baseName;
- (id)initWithDatabaseName:(NSString*)baseName andDatamodelName:(NSString*)modelName;

- (BOOL)saveChanges;
- (BOOL)saveChanges:(NSError **)error;
- (void)removeDatabase;

- (void)handleUnresolvedError:(NSError*)error;

- (void) willInitializeManagedObjectContext;
- (void) didInitializeManagedObjectContext;

- (void)setupCoreDatabaseInstance; // override this to do your own setup


@end
