//
//  NSManagedObject+UID.h
//  DieBauern
//
//  Created by Kasprzak Ingo on 24.02.12.
//  Copyright (c) 2012 Silutions. All rights reserved.
//

#import <CoreData/CoreData.h>

#define PropertyDictionaryEntityNameKey @"EntityName"
#define ManagedObjectModificationDateKey @"modificationDate"
#define ManagedObjectModificationDeviceUid @"modificationDeviceUid"
#define ManagedObjectCreationDateKey @"creationDate"
#define ManagedObjectUIDKey @"uid"


@interface NSManagedObject (UID)

+ (NSString*)thisDeviceUid;

+ (BOOL)synchronizing; // wird von SyncDatabase gesetzt, wenn gerade Objekte synchronisiert werden 
+ (void)setSynchronizing:(BOOL)synchronizing;

// Methoden fürs Method swizzling
- (void)awakeFromInsert_custom;
- (void)willSave_custom;
- (void)prepareForDeletion_custom;

@end

@interface NSManagedObjectContext (UID)

// Eine weitere Methode fürs Method swizzling
- (BOOL)save_custom:(NSError **)error;

@end